Index: tps-ui/redhat-pki-tps-ui.spec
===================================================================
--- tps-ui/redhat-pki-tps-ui.spec	(revision 16069)
+++ tps-ui/redhat-pki-tps-ui.spec	(working copy)
@@ -35,7 +35,7 @@
 ## Package Header Definitions
 %define base_name         %{base_ui_prefix}-%{base_prefix}-%{base_component}
 %define base_version      8.1.0
-%define base_release      7%{?base_build_tag}
+%define base_release      8%{?base_build_tag}
 %define base_phase        %{nil}
 %define base_group        System Environment/Base
 %define base_vendor       Red Hat, Inc.
@@ -230,6 +230,9 @@
 ###############################################################################
 
 %changelog
+* Fri Mar 22 2013 Ade Lee <alee@redhat.com> 8.1.0-8
+- Bugzilla Bug #923414 - Fresh install of CA returns 404s.
+
 * Tue Sep 27 2011 Andrew Wnuk <awnuk@redhat.com> 8.1.0-7
 - Bugzilla Bug #737184 - TPS UI display admin user name as
   "undefined TUS Administrator".
Index: tps-ui/shared/docroot/css/pki-360.css
===================================================================
--- tps-ui/shared/docroot/css/pki-360.css	(revision 16069)
+++ tps-ui/shared/docroot/css/pki-360.css	(working copy)
@@ -39,7 +39,7 @@
 	padding: 0;
 	color: #333;
 	text-align: center;
-	background: #fff url(/img/bkgrnd_greydots.png) repeat;
+	background: #fff;
 	font-family: "Luxi Sans", "Bitstream Vera Sans", "Lucida Grande", "Trebuchet MS", helvetica, verdana, arial, sans-serif;
 	}
 	
@@ -134,7 +134,6 @@
 	float: left;
 	width: 66px;
 	height: 1.1em;
-	background: url(/img/account_loggedin.gif) 100% 100% no-repeat;
 	}
 	
 #account dd {	/* note changes to dl, dt and dd   */
@@ -151,7 +150,6 @@
 #account p a {
 	width: 56px;
 	height: 1.1em;
-	background: url(/img/account_signout.gif) 100% 100% no-repeat;
 	display: block;
 	}
 	
@@ -180,11 +178,10 @@
 #systembar {
 	float: right;
 	width: 34%;
-	background: #e6e6e6 url(/img/greybar_tr.gif) 100% 0 no-repeat;
+	background: #e6e6e6;
 	}
 	
 #systembarinner {
-	background: url(/img/greybar_br.gif) 100% 100% no-repeat;
 	height: 2.8em;
 	/* text-align: center; */
 	text-align: right;
@@ -200,12 +197,11 @@
 #searchbar {
 	float: left;
 	width: 66%;
-	background: #e6e6e6 url(/img/greybar_tl.gif) 0 0 no-repeat;
+	background: #e6e6e6;
 	}
 	
 #searchbarinner {
 	padding-left: 10px;
-	background: url(/img/greybar_bl.gif) 0 100% no-repeat;
 	height: 2.8em;
 	/*
 	text-align: left;
@@ -227,9 +223,6 @@
 #sidenav {	/* for ie55  */
 	width: 132px;
 	background-color: #999;
-	background-image: url(/img/corner_sidenav_top.gif);
-	background-position: top right;
-	background-repeat: no-repeat;
 	font-family: "Luxi Sans", verdana, arial, sans-serif;	
 	font-size: xx-small;
     /* false value for WinIE4/5 */
@@ -244,9 +237,6 @@
 
 	
 #sidenav ul {
-	background-image: url(/img/corner_sidenav_bottom.gif);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	list-style: none;
 	padding: 10px 0 10px 0;
 	margin: 0;
@@ -321,7 +311,6 @@
 /* The following styles establish the legend boxes in the left sidebar */
 .sideleg {
 	width: 132px;
-	background: url(/img/sidelegend_top.gif) 0 0 no-repeat;
 	padding-top: 9px;
 	margin-top: 1em;
 	}
@@ -340,7 +329,6 @@
 	padding: 0 0 9px 0 ;
 	margin: 0;
 	list-style: none;
-	background: url(/img/sidelegend_bottom.gif) 0 100% no-repeat;
 	}
 	
 .sideleg ul li {
@@ -399,7 +387,7 @@
 
 /* -- YOUR PKI stuff -- */
 table.half-table {
-	background: #b4b19a url(/img/table_corner_tr.gif) 100% 0 no-repeat;
+	background: #b4b19a;
 	padding: 0px;
 	margin: 0px;
 	}
@@ -419,7 +407,6 @@
 }
 
 table.half-table thead th:first-child { 
-	background: url(/img/table_corner_tl.gif) top left no-repeat;
 	}
 
 
@@ -428,7 +415,7 @@
 /* -- General list stuff -- */
 table.list {
 	font-size: 10px;
-	background: #b4b19a url(/img/table_corner_tr.gif) top right no-repeat;
+	background: #b4b19a;
 	border-bottom: 1px solid #b4b19a;
 }
 
@@ -439,7 +426,6 @@
 
 
 table.list thead th:first-child {
-	background: url(/img/table_corner_tl.gif) top left no-repeat;
 	}
 
 table.list-pagination {
@@ -568,24 +554,15 @@
 }
 
 h1#pki_welcome {
-	background-image: url(/img/pki_welcome.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	padding-bottom: 5px;
 	height: 20px;
 	}
 	
 h1#pki_welcome2 {
-	background-image: url(/img/pki_welcome2.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	height: 37px;
 	}
 	
 h1#pki_welcome3 {
-	background-image: url(/img/pki_welcome3.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	height: 40px;
 	}
 	
@@ -608,9 +585,6 @@
 	}
 	
 ul.linkage li{
-	background-image: url(/img/bullet_arrowblue.png);
-	background-repeat: no-repeat;
-	background-position: 0 .4em;
 	padding-left: 10px;
 	margin: .4em 0;
 	}
@@ -628,7 +602,6 @@
  
  .clearBox {
  	width: 279px;
- 	background: url(/img/corner_halflinebox_top.png) top right no-repeat;
  	}
  	
  .clearBox {
@@ -637,7 +610,6 @@
  	}
  	
  .clearBoxInner {
- 	background: url(/img/corner_halflinebox_bottom.png) bottom left no-repeat;
  	}
  	
  .clearBoxInner {
@@ -762,7 +734,6 @@
 	}
 		
 ul.content-nav-rowtwo {
-	background: url(/img/contentnav_rowtwo_b.gif) bottom left no-repeat;
 	padding-bottom: 6px;
 	margin-right: 8px;
 	}
@@ -778,36 +749,30 @@
 	}
 		
 ul.content-nav-rowone li.content-nav-selected {
-	background: url(/img/contentnav_tabr.gif) top right no-repeat;
 	}
 		
 ul.content-nav-rowone a.content-nav-selected-link {
-	background: url(/img/contentnav_tabl.gif) top left no-repeat;
 	}
 		
 ul.content-nav-rowthree li.content-nav-selected {
-	background: url(/img/contentnav_tabr.gif) bottom right no-repeat;
 	}
 		
 ul.content-nav-rowthree a.content-nav-selected-link {
-	background: url(/img/contentnav_tabl.gif) bottom left no-repeat;
 	}
 		
 div.contentnav-row2 {
-	background: #e6e6e6 url(/img/contentnav_rowtwo_t.gif) top left no-repeat;
+	background: #e6e6e6;
 	padding: 0px;
 	clear: left;
 	}
 		
 div.contentnav-row2 div.top {
-	background: url(/img/contentnav_rowtwo_t.gif) top right no-repeat;
 	margin-left: 8px;
 	height: 6px;
 	font-size: 0;
 	}
 		
 div.contentnav-row2 div.bottom {
-	background: url(/img/contentnav_rowtwo_b.gif) bottom right no-repeat;
 	}
 		
 /* CONTENTNAV - end */
@@ -819,9 +784,6 @@
 	
 #mainNavOuter {
 	width: 100%;
-	background-image: url(/img/corner_mainnav_bottom_chopped.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	background-color: #cc0000;
 	}
 	
@@ -851,18 +813,12 @@
 #mainNavInner {
 	width: 100%;
 	height: 7px;
-	background-image: url(/img/corner_mainnav_top_chopped.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul {
 	padding: 0;
 	margin: 0;
 	list-style-type: none;
-	background-image: url(/img/corner_mainnav_tl.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li {
@@ -882,52 +838,28 @@
 
 /* special casing for left-most top tab */
 #mainNav ul li a.mainFirstLink {
-	background-image: url(/img/corner_mainnav_tl.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainFirst-active a.mainFirstLink {
-	background-image: url(/img/corner_mainnav_tl_hi.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li#mainFirst {
-	background-image: url(/img/corner_mainnav_bl.png);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainFirst-active {
-	background-image: url(/img/corner_mainnav_bl_hi.png);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	}
 
 /* special casing for right-most top tab */	
 #mainNav ul li a.mainLastLink {
-	background-image: url(/img/corner_mainnav_tr.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainLast-active a.mainLastLink {
-	background-image: url(/img/corner_mainnav_tr_hi.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li#mainLast {
-	background-image: url(/img/corner_mainnav_br.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainLast-active {
-	background-image: url(/img/corner_mainnav_br_hi.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li a {
Index: tps-ui/shared/docroot/css/pki-base.css
===================================================================
--- tps-ui/shared/docroot/css/pki-base.css	(revision 16069)
+++ tps-ui/shared/docroot/css/pki-base.css	(working copy)
@@ -89,7 +89,7 @@
 }
 
 .bar-undertabs div {
-	background: #900 url("/img/tab-bar.gif") repeat-x bottom;
+	background: #900;
         height: 11px;
         font-size: 1px;
         margin: 0;
Index: tps-ui/shared/docroot/css/pki.css
===================================================================
--- tps-ui/shared/docroot/css/pki.css	(revision 16069)
+++ tps-ui/shared/docroot/css/pki.css	(working copy)
@@ -117,7 +117,6 @@
 	padding-top: 0;
 }
 .list-channel li li {
-	list-style-image: url("/img/branch.gif");
 	margin-left: 2.5em;
 }
 
@@ -156,7 +155,7 @@
 }
 
 .tab-row td {
-	background: #fff url("/img/tab-bar-top.gif") repeat-x bottom;
+	background: #fff;
 }
 
 hr {
Index: ra-ui/shared/docroot/css/pki-360.css
===================================================================
--- ra-ui/shared/docroot/css/pki-360.css	(revision 16067)
+++ ra-ui/shared/docroot/css/pki-360.css	(working copy)
@@ -39,7 +39,7 @@
 	padding: 0;
 	color: #333;
 	text-align: center;
-	background: #fff url(/img/bkgrnd_greydots.png) repeat;
+	background: #fff;
 	font-family: "Luxi Sans", "Bitstream Vera Sans", "Lucida Grande", "Trebuchet MS", helvetica, verdana, arial, sans-serif;
 	}
 	
@@ -134,7 +134,6 @@
 	float: left;
 	width: 66px;
 	height: 1.1em;
-	background: url(/img/account_loggedin.gif) 100% 100% no-repeat;
 	}
 	
 #account dd {	/* note changes to dl, dt and dd   */
@@ -151,7 +150,6 @@
 #account p a {
 	width: 56px;
 	height: 1.1em;
-	background: url(/img/account_signout.gif) 100% 100% no-repeat;
 	display: block;
 	}
 	
@@ -180,11 +178,10 @@
 #systembar {
 	float: right;
 	width: 34%;
-	background: #e6e6e6 url(/img/greybar_tr.gif) 100% 0 no-repeat;
+	background: #e6e6e6;
 	}
 	
 #systembarinner {
-	background: url(/img/greybar_br.gif) 100% 100% no-repeat;
 	height: 2.8em;
 	/* text-align: center; */
 	text-align: right;
@@ -200,12 +197,11 @@
 #searchbar {
 	float: left;
 	width: 66%;
-	background: #e6e6e6 url(/img/greybar_tl.gif) 0 0 no-repeat;
+	background: #e6e6e6;
 	}
 	
 #searchbarinner {
 	padding-left: 10px;
-	background: url(/img/greybar_bl.gif) 0 100% no-repeat;
 	height: 2.8em;
 	/*
 	text-align: left;
@@ -227,9 +223,6 @@
 #sidenav {	/* for ie55  */
 	width: 132px;
 	background-color: #999;
-	background-image: url(/img/corner_sidenav_top.gif);
-	background-position: top right;
-	background-repeat: no-repeat;
 	font-family: "Luxi Sans", verdana, arial, sans-serif;	
 	font-size: xx-small;
     /* false value for WinIE4/5 */
@@ -244,9 +237,6 @@
 
 	
 #sidenav ul {
-	background-image: url(/img/corner_sidenav_bottom.gif);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	list-style: none;
 	padding: 10px 0 10px 0;
 	margin: 0;
@@ -321,7 +311,6 @@
 /* The following styles establish the legend boxes in the left sidebar */
 .sideleg {
 	width: 132px;
-	background: url(/img/sidelegend_top.gif) 0 0 no-repeat;
 	padding-top: 9px;
 	margin-top: 1em;
 	}
@@ -340,7 +329,6 @@
 	padding: 0 0 9px 0 ;
 	margin: 0;
 	list-style: none;
-	background: url(/img/sidelegend_bottom.gif) 0 100% no-repeat;
 	}
 	
 .sideleg ul li {
@@ -399,7 +387,7 @@
 
 /* -- YOUR PKI stuff -- */
 table.half-table {
-	background: #b4b19a url(/img/table_corner_tr.gif) 100% 0 no-repeat;
+	background: #b4b19a;
 	padding: 0px;
 	margin: 0px;
 	}
@@ -419,7 +407,6 @@
 }
 
 table.half-table thead th:first-child { 
-	background: url(/img/table_corner_tl.gif) top left no-repeat;
 	}
 
 
@@ -428,7 +415,7 @@
 /* -- General list stuff -- */
 table.list {
 	font-size: 10px;
-	background: #b4b19a url(/img/table_corner_tr.gif) top right no-repeat;
+	background: #b4b19a;
 	border-bottom: 1px solid #b4b19a;
 }
 
@@ -439,7 +426,6 @@
 
 
 table.list thead th:first-child {
-	background: url(/img/table_corner_tl.gif) top left no-repeat;
 	}
 
 table.list-pagination {
@@ -568,24 +554,15 @@
 }
 
 h1#pki_welcome {
-	background-image: url(/img/pki_welcome.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	padding-bottom: 5px;
 	height: 20px;
 	}
 	
 h1#pki_welcome2 {
-	background-image: url(/img/pki_welcome2.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	height: 37px;
 	}
 	
 h1#pki_welcome3 {
-	background-image: url(/img/pki_welcome3.gif);
-	background-position: 0 0;
-	background-repeat: no-repeat;
 	height: 40px;
 	}
 	
@@ -608,9 +585,6 @@
 	}
 	
 ul.linkage li{
-	background-image: url(/img/bullet_arrowblue.png);
-	background-repeat: no-repeat;
-	background-position: 0 .4em;
 	padding-left: 10px;
 	margin: .4em 0;
 	}
@@ -628,7 +602,6 @@
  
  .clearBox {
  	width: 279px;
- 	background: url(/img/corner_halflinebox_top.png) top right no-repeat;
  	}
  	
  .clearBox {
@@ -637,7 +610,6 @@
  	}
  	
  .clearBoxInner {
- 	background: url(/img/corner_halflinebox_bottom.png) bottom left no-repeat;
  	}
  	
  .clearBoxInner {
@@ -762,7 +734,6 @@
 	}
 		
 ul.content-nav-rowtwo {
-	background: url(/img/contentnav_rowtwo_b.gif) bottom left no-repeat;
 	padding-bottom: 6px;
 	margin-right: 8px;
 	}
@@ -778,36 +749,30 @@
 	}
 		
 ul.content-nav-rowone li.content-nav-selected {
-	background: url(/img/contentnav_tabr.gif) top right no-repeat;
 	}
 		
 ul.content-nav-rowone a.content-nav-selected-link {
-	background: url(/img/contentnav_tabl.gif) top left no-repeat;
 	}
 		
 ul.content-nav-rowthree li.content-nav-selected {
-	background: url(/img/contentnav_tabr.gif) bottom right no-repeat;
 	}
 		
 ul.content-nav-rowthree a.content-nav-selected-link {
-	background: url(/img/contentnav_tabl.gif) bottom left no-repeat;
 	}
 		
 div.contentnav-row2 {
-	background: #e6e6e6 url(/img/contentnav_rowtwo_t.gif) top left no-repeat;
+	background: #e6e6e6;
 	padding: 0px;
 	clear: left;
 	}
 		
 div.contentnav-row2 div.top {
-	background: url(/img/contentnav_rowtwo_t.gif) top right no-repeat;
 	margin-left: 8px;
 	height: 6px;
 	font-size: 0;
 	}
 		
 div.contentnav-row2 div.bottom {
-	background: url(/img/contentnav_rowtwo_b.gif) bottom right no-repeat;
 	}
 		
 /* CONTENTNAV - end */
@@ -819,9 +784,6 @@
 	
 #mainNavOuter {
 	width: 100%;
-	background-image: url(/img/corner_mainnav_bottom_chopped.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	background-color: #cc0000;
 	}
 	
@@ -851,18 +813,12 @@
 #mainNavInner {
 	width: 100%;
 	height: 7px;
-	background-image: url(/img/corner_mainnav_top_chopped.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul {
 	padding: 0;
 	margin: 0;
 	list-style-type: none;
-	background-image: url(/img/corner_mainnav_tl.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li {
@@ -882,52 +838,28 @@
 
 /* special casing for left-most top tab */
 #mainNav ul li a.mainFirstLink {
-	background-image: url(/img/corner_mainnav_tl.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainFirst-active a.mainFirstLink {
-	background-image: url(/img/corner_mainnav_tl_hi.png);
-	background-position: top left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li#mainFirst {
-	background-image: url(/img/corner_mainnav_bl.png);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainFirst-active {
-	background-image: url(/img/corner_mainnav_bl_hi.png);
-	background-position: bottom left;
-	background-repeat: no-repeat;
 	}
 
 /* special casing for right-most top tab */	
 #mainNav ul li a.mainLastLink {
-	background-image: url(/img/corner_mainnav_tr.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainLast-active a.mainLastLink {
-	background-image: url(/img/corner_mainnav_tr_hi.png);
-	background-position: top right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li#mainLast {
-	background-image: url(/img/corner_mainnav_br.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav li#mainLast-active {
-	background-image: url(/img/corner_mainnav_br_hi.png);
-	background-position: bottom right;
-	background-repeat: no-repeat;
 	}
 	
 #mainNav ul li a {
Index: ra-ui/shared/docroot/css/pki-base.css
===================================================================
--- ra-ui/shared/docroot/css/pki-base.css	(revision 16067)
+++ ra-ui/shared/docroot/css/pki-base.css	(working copy)
@@ -89,7 +89,7 @@
 }
 
 .bar-undertabs div {
-	background: #900 url("/img/tab-bar.gif") repeat-x bottom;
+	background: #900;
         height: 11px;
         font-size: 1px;
         margin: 0;
Index: ra-ui/shared/docroot/css/pki.css
===================================================================
--- ra-ui/shared/docroot/css/pki.css	(revision 16067)
+++ ra-ui/shared/docroot/css/pki.css	(working copy)
@@ -117,7 +117,6 @@
 	padding-top: 0;
 }
 .list-channel li li {
-	list-style-image: url("/img/branch.gif");
 	margin-left: 2.5em;
 }
 
@@ -156,7 +155,7 @@
 }
 
 .tab-row td {
-	background: #fff url("/img/tab-bar-top.gif") repeat-x bottom;
+	background: #fff;
 }
 
 hr {
Index: ra-ui/redhat-pki-ra-ui.spec
===================================================================
--- ra-ui/redhat-pki-ra-ui.spec	(revision 16067)
+++ ra-ui/redhat-pki-ra-ui.spec	(working copy)
@@ -35,7 +35,7 @@
 ## Package Header Definitions
 %define base_name         %{base_ui_prefix}-%{base_prefix}-%{base_component}
 %define base_version      8.1.0
-%define base_release      4%{?base_build_tag}
+%define base_release      5%{?base_build_tag}
 %define base_phase        %{nil}
 %define base_group        System Environment/Base
 %define base_vendor       Red Hat, Inc.
@@ -230,6 +230,9 @@
 ###############################################################################
 
 %changelog
+* Fri Mar 22 2013 Ade Lee <alee@redhat.com> 8.1.0-5
+- Bugzilla Bug #923414 - Fresh install of CA returns 404s.
+
 * Wed Jul 6 2011 Ade Lee <alee@redhat.com> 8.1.0-4
 - Bugzilla Bug #706306 - scripts to allow in-place migration from 8.0 to 8.1
 