From e74838f385509484b45d53a8a2ff6b13db3db454 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Wed, 21 Nov 2012 14:30:45 -0500
Subject: [PATCH] Reorganized TPS CSS files.

The CSS files for TPS have been moved into the server theme package.
All references have been modified accordingly.

Ticket #407
---
 base/tps/apache/cgi-bin/demo/Enroll.html                              | 2 +-
 base/tps/apache/cgi-bin/home/Enroll.html                              | 2 +-
 base/tps/apache/cgi-bin/home/cachain.cgi                              | 2 +-
 base/tps/apache/cgi-bin/so/Enroll.html                                | 2 +-
 base/tps/apache/cgi-bin/sow/enroll.html                               | 4 ++--
 base/tps/apache/cgi-bin/sow/enroll_temp.html                          | 4 ++--
 base/tps/apache/cgi-bin/sow/format.html                               | 4 ++--
 base/tps/apache/cgi-bin/sow/formatso.html                             | 4 ++--
 base/tps/apache/cgi-bin/sow/main.html                                 | 4 ++--
 base/tps/apache/cgi-bin/sow/noaccess.html                             | 4 ++--
 base/tps/apache/cgi-bin/sow/read.html                                 | 4 ++--
 base/tps/apache/cgi-bin/sow/read_temp.html                            | 4 ++--
 base/tps/apache/cgi-bin/sow/search.html                               | 4 ++--
 base/tps/apache/cgi-bin/sow/search_temp.html                          | 4 ++--
 base/tps/apache/cgi-bin/sow/seturl.html                               | 4 ++--
 base/tps/apache/cgi-bin/sow/welcome.html                              | 4 ++--
 base/tps/apache/docroot/esc/AdminEsc.html                             | 2 +-
 base/tps/apache/docroot/esc/AdvancePopup.html                         | 2 +-
 base/tps/apache/docroot/esc/EnrollPopup.html                          | 2 +-
 base/tps/apache/docroot/esc/SettingsEsc.html                          | 2 +-
 base/tps/apache/docroot/esc/TokenManager.html                         | 2 +-
 base/tps/apache/docroot/esc/demo/EnrollSuccess.html                   | 2 +-
 base/tps/apache/docroot/esc/home/EnrollSuccess.html                   | 2 +-
 base/tps/apache/docroot/esc/so/EnrollSuccess.html                     | 2 +-
 base/tps/apache/docroot/esc/sow/EnrollSuccess.html                    | 4 ++--
 dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/demo/style.css | 0
 dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/home/style.css | 0
 dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/so/style.css   | 0
 .../{tps-ui/shared/docroot => common-ui/shared}/esc/sow/css/style.css | 0
 dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/sow/style.css  | 0
 dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/style.css      | 0
 31 files changed, 38 insertions(+), 38 deletions(-)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/demo/style.css (100%)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/home/style.css (100%)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/so/style.css (100%)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/sow/css/style.css (100%)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/sow/style.css (100%)
 rename dogtag/{tps-ui/shared/docroot => common-ui/shared}/esc/style.css (100%)

diff --git a/base/tps/apache/cgi-bin/demo/Enroll.html b/base/tps/apache/cgi-bin/demo/Enroll.html
index df00dbee43179536d76150fbc20f02a3d5e4ee0c..79c660712411af5be8345149b53184cc362cb552 100755
--- a/base/tps/apache/cgi-bin/demo/Enroll.html
+++ b/base/tps/apache/cgi-bin/demo/Enroll.html
@@ -19,7 +19,7 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/demo/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/demo/style.css" type="text/css">
 
 <title>Enrollment</title>
 </head>
diff --git a/base/tps/apache/cgi-bin/home/Enroll.html b/base/tps/apache/cgi-bin/home/Enroll.html
index 218da280c0b485be4b803b4586298bc8192bc409..2bcc9c1af5abb6590499042be7e08e1b37727ab6 100755
--- a/base/tps/apache/cgi-bin/home/Enroll.html
+++ b/base/tps/apache/cgi-bin/home/Enroll.html
@@ -18,7 +18,7 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/home/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/home/style.css" type="text/css">
 
 <title>Enrollment</title>
 </head>
diff --git a/base/tps/apache/cgi-bin/home/cachain.cgi b/base/tps/apache/cgi-bin/home/cachain.cgi
index ddbf5e6ae18afc35c631ec990c48dc8fdde9b6b6..27dc9cd6cc4038dc4e418368279257e750c3e7f5 100755
--- a/base/tps/apache/cgi-bin/home/cachain.cgi
+++ b/base/tps/apache/cgi-bin/home/cachain.cgi
@@ -45,7 +45,7 @@ if ($response->is_success) {
 } else {
    print "Content-type: text/html\n\n";
    print "<html>";
-   print "<link rel=stylesheet href='/esc/home/style.css' type='text/css'>";
+   print "<link rel=stylesheet href='/pki/esc/home/style.css' type='text/css'>";
    print "<center><h2>Error Importing CA Chain Information!</h2></center>";
    print "<center><h2>Please try again later.</h2></center>";
    print "</html>"
diff --git a/base/tps/apache/cgi-bin/so/Enroll.html b/base/tps/apache/cgi-bin/so/Enroll.html
index 3d2fa6daa3604c1ebb03667dc45f9f20e3449632..1e4f137e56a628da21f7d924e4d8c8d61a0c3506 100755
--- a/base/tps/apache/cgi-bin/so/Enroll.html
+++ b/base/tps/apache/cgi-bin/so/Enroll.html
@@ -18,7 +18,7 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/so/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/so/style.css" type="text/css">
 
 <title>Enrollment</title>
 </head>
diff --git a/base/tps/apache/cgi-bin/sow/enroll.html b/base/tps/apache/cgi-bin/sow/enroll.html
index 7bc377ffea1bc7939f8cee29c16c819a0a1424bc..81ec73443d9ba8302a21705e7f2adadd4014370c 100755
--- a/base/tps/apache/cgi-bin/sow/enroll.html
+++ b/base/tps/apache/cgi-bin/sow/enroll.html
@@ -18,13 +18,13 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Enrollment</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
 <script type="text/JavaScript" src="/esc/sow/util.js"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 <script type="text/javascript">
 <!--
 function UserOnCOOLKeyStateError()
diff --git a/base/tps/apache/cgi-bin/sow/enroll_temp.html b/base/tps/apache/cgi-bin/sow/enroll_temp.html
index 3f2b31ce6e74ea8f8a05642243fa5db8123cf906..342eddb1bc9bac635cab85c22c6664fab0fe6b55 100755
--- a/base/tps/apache/cgi-bin/sow/enroll_temp.html
+++ b/base/tps/apache/cgi-bin/sow/enroll_temp.html
@@ -18,13 +18,13 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Enrollment</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
 <script type="text/JavaScript" src="/esc/sow/util.js"></script>
-<link rel="stylesheet" href="/esc/sow/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 <script type="text/javascript">
 <!--
 function UserOnCOOLKeyStateError()
diff --git a/base/tps/apache/cgi-bin/sow/format.html b/base/tps/apache/cgi-bin/sow/format.html
index 3af35589bee9cf6032c3dac063bdb4f19923ffea..66b19a6247f0dd89883896e27139855185ac8a6b 100755
--- a/base/tps/apache/cgi-bin/sow/format.html
+++ b/base/tps/apache/cgi-bin/sow/format.html
@@ -18,13 +18,13 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Enrollment</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
 <script type="text/JavaScript" src="/esc/sow/util.js"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 <script type="text/javascript">
 <!--
 
diff --git a/base/tps/apache/cgi-bin/sow/formatso.html b/base/tps/apache/cgi-bin/sow/formatso.html
index d09666c5a66de305317ef89ca433696f965f2db2..3508d633ef0bd7814707b73f66d394b30973dfef 100755
--- a/base/tps/apache/cgi-bin/sow/formatso.html
+++ b/base/tps/apache/cgi-bin/sow/formatso.html
@@ -18,13 +18,13 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Enrollment</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
 <script type="text/JavaScript" src="/esc/sow/util.js"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 <script type="text/javascript">
 <!--
 function UserOnCOOLKeyStateError()
diff --git a/base/tps/apache/cgi-bin/sow/main.html b/base/tps/apache/cgi-bin/sow/main.html
index e7de688bcecadab20cca96d0625c6915595a675b..897be5920cb479cb2b37321cf604758f1c98d8f8 100755
--- a/base/tps/apache/cgi-bin/sow/main.html
+++ b/base/tps/apache/cgi-bin/sow/main.html
@@ -18,10 +18,10 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Security Officer</title>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/noaccess.html b/base/tps/apache/cgi-bin/sow/noaccess.html
index 06e9fa2d824de9411843df40dcbc055d82e7d166..80cdd11d7c4de0c233428dc26dc3cdeb4066388b 100755
--- a/base/tps/apache/cgi-bin/sow/noaccess.html
+++ b/base/tps/apache/cgi-bin/sow/noaccess.html
@@ -18,10 +18,10 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Security Officer</title>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/read.html b/base/tps/apache/cgi-bin/sow/read.html
index 1e660c84f6c4b7442bfa4beff9cdec96cc96a9e3..ca1c5f9d35720082899999ca411d5ea1f30fa328 100755
--- a/base/tps/apache/cgi-bin/sow/read.html
+++ b/base/tps/apache/cgi-bin/sow/read.html
@@ -18,12 +18,12 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/css/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/css/style.css" type="text/css">
 
 <title>Security Officer</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/read_temp.html b/base/tps/apache/cgi-bin/sow/read_temp.html
index 1e660c84f6c4b7442bfa4beff9cdec96cc96a9e3..ca1c5f9d35720082899999ca411d5ea1f30fa328 100755
--- a/base/tps/apache/cgi-bin/sow/read_temp.html
+++ b/base/tps/apache/cgi-bin/sow/read_temp.html
@@ -18,12 +18,12 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/css/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/css/style.css" type="text/css">
 
 <title>Security Officer</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/search.html b/base/tps/apache/cgi-bin/sow/search.html
index 789a4a0155ee9affdc3e7535fbbc5c9120eb43c3..5b66fcd4834b74fe3f5ff244ccc0aab26fec7654 100755
--- a/base/tps/apache/cgi-bin/sow/search.html
+++ b/base/tps/apache/cgi-bin/sow/search.html
@@ -18,10 +18,10 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Security Officer</title>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/search_temp.html b/base/tps/apache/cgi-bin/sow/search_temp.html
index 507f223efb216d6c95cab8c581d658c22460d377..6f00963056d9131c51d69df4bdf171237169df76 100755
--- a/base/tps/apache/cgi-bin/sow/search_temp.html
+++ b/base/tps/apache/cgi-bin/sow/search_temp.html
@@ -18,10 +18,10 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Security Officer</title>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/cgi-bin/sow/seturl.html b/base/tps/apache/cgi-bin/sow/seturl.html
index 966ab7a1b61d7cc7c3978b7c17ec526e95545057..f1cddb186e5a9ed5951ad14f952cf5c1f935fd65 100755
--- a/base/tps/apache/cgi-bin/sow/seturl.html
+++ b/base/tps/apache/cgi-bin/sow/seturl.html
@@ -18,13 +18,13 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Enrollment</title>
 <script type="text/javascript" src="/esc/sow/js/prototype.js"></script>
 <script type="text/javascript" src="/esc/sow/js/scriptaculous.js?load=effects"></script>
 <script type="text/JavaScript" src="/esc/sow/util.js"></script>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 <script type="text/javascript">
 <!--
 function UserOnCOOLKeyStateError()
diff --git a/base/tps/apache/cgi-bin/sow/welcome.html b/base/tps/apache/cgi-bin/sow/welcome.html
index 718dce94b012af58871e3feabe766686d965b8ce..c539f17b710563ff2a13753b9ae6c3ff7804ac37 100755
--- a/base/tps/apache/cgi-bin/sow/welcome.html
+++ b/base/tps/apache/cgi-bin/sow/welcome.html
@@ -18,10 +18,10 @@
 <html>
 <head>
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 
 <title>Security Officer</title>
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/base/tps/apache/docroot/esc/AdminEsc.html b/base/tps/apache/docroot/esc/AdminEsc.html
index 3fd72c4c8bd1dc9ed35c87677f8b6edaa02f1d9c..f17e8c4729b2b85c0a8ecf0b0140a56793ce7fc4 100755
--- a/base/tps/apache/docroot/esc/AdminEsc.html
+++ b/base/tps/apache/docroot/esc/AdminEsc.html
@@ -20,7 +20,7 @@
 <head>
 <title>Enterprise Security Administration Page</title>
 
-<link rel=stylesheet href="/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/style.css" type="text/css">
 
 </head>
 <body>
diff --git a/base/tps/apache/docroot/esc/AdvancePopup.html b/base/tps/apache/docroot/esc/AdvancePopup.html
index c918890442342dab8af048d755d72b9dd6618e59..4606539c63a9961df4242e7882fed6dda2463c7f 100755
--- a/base/tps/apache/docroot/esc/AdvancePopup.html
+++ b/base/tps/apache/docroot/esc/AdvancePopup.html
@@ -19,7 +19,7 @@
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
 
 <head>
-<link rel=stylesheet href="/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/style.css" type="text/css">
 
 <script language="JavaScript">
 
diff --git a/base/tps/apache/docroot/esc/EnrollPopup.html b/base/tps/apache/docroot/esc/EnrollPopup.html
index ead7db355ce7b6a3cc1f9c3ee4bf417951c14c55..02ed473057104c293f6bf45fae37304f0f4924cf 100755
--- a/base/tps/apache/docroot/esc/EnrollPopup.html
+++ b/base/tps/apache/docroot/esc/EnrollPopup.html
@@ -19,7 +19,7 @@
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
 
 <head>
-<link rel=stylesheet href="/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/style.css" type="text/css">
 
 <script language="JavaScript">
 
diff --git a/base/tps/apache/docroot/esc/SettingsEsc.html b/base/tps/apache/docroot/esc/SettingsEsc.html
index 0340ee64cf816ffc642ea7d2216ee3bbf577bd6d..7bc1efc79743d2aa21b34daa2031dfc0e5d52ea9 100755
--- a/base/tps/apache/docroot/esc/SettingsEsc.html
+++ b/base/tps/apache/docroot/esc/SettingsEsc.html
@@ -19,7 +19,7 @@
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
 <head>
 
-<link rel=stylesheet href="/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/style.css" type="text/css">
 
 <script lang="JavaScript">
 //
diff --git a/base/tps/apache/docroot/esc/TokenManager.html b/base/tps/apache/docroot/esc/TokenManager.html
index fcd6beec9b8ec106027038021e8352b39dfec545..010c21ac9fff00948659f6b05622ed840f29cf16 100755
--- a/base/tps/apache/docroot/esc/TokenManager.html
+++ b/base/tps/apache/docroot/esc/TokenManager.html
@@ -19,7 +19,7 @@
 <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
 
 <head>
-<link rel=stylesheet href="/style.css" type="text/css">
+<link rel=stylesheet href="/pki/esc/style.css" type="text/css">
 
 <script language="JavaScript">
 
diff --git a/base/tps/apache/docroot/esc/demo/EnrollSuccess.html b/base/tps/apache/docroot/esc/demo/EnrollSuccess.html
index 2a9d2b38642bc8e9f3f3cfeb29b74bc443cb639b..7c95a5568c8926bfca775e54f81b55553c93d5e0 100644
--- a/base/tps/apache/docroot/esc/demo/EnrollSuccess.html
+++ b/base/tps/apache/docroot/esc/demo/EnrollSuccess.html
@@ -18,7 +18,7 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
-<link rel=stylesheet href="/demo/style.css" type="text/css"> 
+<link rel=stylesheet href="/pki/esc/demo/style.css" type="text/css">
 <title>Success!</title>
 <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
 </head>
diff --git a/base/tps/apache/docroot/esc/home/EnrollSuccess.html b/base/tps/apache/docroot/esc/home/EnrollSuccess.html
index fbe8d241fa7325fb088fcc85a91034a958a26a76..2dd6b72e588f0fe7c116496835030330fdceb8ea 100644
--- a/base/tps/apache/docroot/esc/home/EnrollSuccess.html
+++ b/base/tps/apache/docroot/esc/home/EnrollSuccess.html
@@ -18,7 +18,7 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
-<link rel=stylesheet href="/home/style.css" type="text/css"> 
+<link rel=stylesheet href="/pki/esc/home/style.css" type="text/css">
 <title>Success!</title>
 <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
 </head>
diff --git a/base/tps/apache/docroot/esc/so/EnrollSuccess.html b/base/tps/apache/docroot/esc/so/EnrollSuccess.html
index 9ed0cebeebb5bf2032afa1e31c2e0f0446e1a5c8..4c9f3deca39d8488f27ae327ecda8edfd8f0309d 100644
--- a/base/tps/apache/docroot/esc/so/EnrollSuccess.html
+++ b/base/tps/apache/docroot/esc/so/EnrollSuccess.html
@@ -18,7 +18,7 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
-<link rel=stylesheet href="/esc/so/style.css" type="text/css"> 
+<link rel=stylesheet href="/pki/esc/so/style.css" type="text/css">
 <title>Success!</title>
 <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
 </head>
diff --git a/base/tps/apache/docroot/esc/sow/EnrollSuccess.html b/base/tps/apache/docroot/esc/sow/EnrollSuccess.html
index 478819213ff482668e159815d617e2662675b06e..41f7b565f09dfd74b071356cdad366e40bea8ba5 100644
--- a/base/tps/apache/docroot/esc/sow/EnrollSuccess.html
+++ b/base/tps/apache/docroot/esc/sow/EnrollSuccess.html
@@ -18,10 +18,10 @@
 <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
 <html>
 <head>
-<link rel=stylesheet href="/esc/sow/style.css" type="text/css"> 
+<link rel=stylesheet href="/pki/esc/sow/style.css" type="text/css">
 <title>Success!</title>
 <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
-<link rel="stylesheet" href="/esc/sow/css/style.css" media="screen" type="text/css">
+<link rel="stylesheet" href="/pki/esc/sow/css/style.css" media="screen" type="text/css">
 </head>
 
 <body>
diff --git a/dogtag/tps-ui/shared/docroot/esc/demo/style.css b/dogtag/common-ui/shared/esc/demo/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/demo/style.css
rename to dogtag/common-ui/shared/esc/demo/style.css
diff --git a/dogtag/tps-ui/shared/docroot/esc/home/style.css b/dogtag/common-ui/shared/esc/home/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/home/style.css
rename to dogtag/common-ui/shared/esc/home/style.css
diff --git a/dogtag/tps-ui/shared/docroot/esc/so/style.css b/dogtag/common-ui/shared/esc/so/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/so/style.css
rename to dogtag/common-ui/shared/esc/so/style.css
diff --git a/dogtag/tps-ui/shared/docroot/esc/sow/css/style.css b/dogtag/common-ui/shared/esc/sow/css/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/sow/css/style.css
rename to dogtag/common-ui/shared/esc/sow/css/style.css
diff --git a/dogtag/tps-ui/shared/docroot/esc/sow/style.css b/dogtag/common-ui/shared/esc/sow/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/sow/style.css
rename to dogtag/common-ui/shared/esc/sow/style.css
diff --git a/dogtag/tps-ui/shared/docroot/esc/style.css b/dogtag/common-ui/shared/esc/style.css
similarity index 100%
rename from dogtag/tps-ui/shared/docroot/esc/style.css
rename to dogtag/common-ui/shared/esc/style.css
-- 
1.7.12.1